<?php
/**********************************************************************
 * $Id: 
 *
 * IMSEmu - A Simple ARCIMS emulator in PHP.
 * http://mapserver.refractions.net
 * Copyright 2001-2003 Refractions Research Inc.
 *
 * This is free software; you can redistribute and/or modify it under
 * the terms of the GNU General Public Licence. See the COPYING file.
 * 
 *********************************************************************/

  if(!extension_loaded('MapScript')) {  
  	$extensionDir = ini_get('extension_dir'); 
  	$dirH = opendir($extensionDir); 
  	$dirArr = array(); 
  	while(($tmp = readdir($dirH)) != false) { 
  		if(strstr($tmp,'php_mapscript')) { 
  			dl($tmp); 
  			break; 
  		} 
  	} 
  	closedir($dirH); 
  } 

  set_time_limit(60);

  require("GetServiceInfo.php");
  require("GetFeatures.php");
  require("GetImage.php");

  ini_set("track_errors", 1);
  if($_SERVER['HTTP_CONNECTION'] == 'Keep-Alive' &&
      $_SERVER['REQUEST_METHOD'] == 'POST') {
//    header("HTTP/ 100");
//    header("HTTP/ 200", true);
  }
  if(isset($_SERVER['HTTP_ACCEPT_ENCODING'])) {
    header("Content-Encoding: none");
  }

  writeLog("Script " . $SCRIPT_FILENAME, 0);

  $map_file = array();
  $map_epsg = array();
  $map_type = array();
  $temp_dir = array();
  $v = getConfiguration($map_file, $map_epsg, $map_type, $temp_dir);
  writeLog("Temp Dir: " . $temp_dir, 5);
  if($v != 0) {
    writeErrorMessageAndDie($output, $tmpfile, 
        "Server error: bad configuration file.");
  }

  /*
   * We currently write all by the simplest responses to a temporary file
   * before sending it.  Some sort of buffering is required if customstream
   * is requested, since the length of the response must be included.
   */
  $tmpfile = tempnam($temp_dir, "imsemu");
  $output = fopen($tmpfile, "w+");

  $starttime = getmicrotime();

  // Image types and extensions
  $imginfo = array("gif" => array(
      "ms" => "gif", "ims" => "gif", "ext" => "gif"),
    "png" => array(
      "ms" => "png", "ims" => "png8", "ext" => "png"),
    "jpg" => array(
      "ms" => "jpeg", "ims" => "jpg", "ext" => "jpg"),
    "png8" => array(
      "ms" => "png", "ims" => "png8", "ext" => "png"));

  $visibleByStatus = array("false", "true", "true", "false");
  $inchesPerUnit = array(1, 12, 63360.0, 39.3701, 39370.1, 4374754);

  // Arcmap likes these lower case
  $unitsByUnit = array("inches", "feet", "miles", "meters", 
      "kilometers", "decimal_degrees");
  $typeMap = array(MS_LAYER_POINT => "point",
      MS_LAYER_LINE => "line", MS_LAYER_POLYGON => "polygon");

  /*
   * ArcMap requires that getclientinfo response have parametes names 
   * all upper case (except the xml and ARCXML tags) but all other
   * request types need lower case param names. WTF!!!
   */
  $needUpper = false;

  /*
   * Another bit of joy, some responses appear to require a carriage
   * return followed by a line feed after each tag, while others 
   * won't function if this is included.  The xml and ARCXML tags
   * are always followed by only the line feed character. 
   */
  $needNewLine = false;

  // Cast all get params to lower case
  $_GET = array_change_key_case($_GET, CASE_LOWER);

  header("Content-Type: text/plain");

  /* 
   * Return valid version information
   * This information was choosen such that ArcMap wouldn't crash, but
   * is quite arbitrary.
   */
  if(strtolower($_GET["cmd"]) == 'getversion') {
    header("");
    echo "Version:4.0.1\n";
    echo "Build_Number:630.1700\n";
    exit;
  }

  // Return expected pong response
  if(strtolower($_GET["cmd"]) == 'ping') {
    echo "IMS v4.0.1\n";
    exit;
  }


  // Read in the input stream to get the unparsed post data
  $bb = fopen("php://input", "rb");
  while (!feof($bb))
  {
    $post .= fread($bb, 4096);
  }
  fclose($bb);

  // Parse the posted xml document
  $xml_parser = xml_parser_create('');

  $v = xml_parse_into_struct($xml_parser, $post, $xml_val, $xml_ind);

  /*
   * Check for a xml format error, and return a standard looking
   * error message.
   * The error message given by PHP isn't very useful.
   */
  if($v == 0) {
    writeLog("Post XML parsing failed.\n" . $php_errormsg, 0);
    writeFullErrorMessageAndDie($output, $tmpfile, 
        "XMLParser: Fatal parsing error:\n '" . $php_errormsg . "'\n");
  }

// Return catalog
  if(strtolower($_GET['servicename']) == 'catalog') {
    writeCatalog($output, $map_file, $map_type, $tmpfile);

// The remaining requests must be determined from the xml doc.
  } elseif(isset($xml_ind['GETCLIENTSERVICES'])) {
    writeCatalog($output, $map_file, $map_type, $tmpfile);
  } elseif(isset($_GET['servicename'])) {
    $servicename = $_GET['servicename'];
    if(isset($xml_ind['REQUEST'])) {
      
      $map = ms_newMapObj($map_file[$servicename]);

      /*
       * Service get_service_info request.  Only the dpi and envelope
       * attributes are used here.
       */
      if(isset($xml_ind['GET_SERVICE_INFO'])) {
        processGetServiceInfo($map, $servicename, $xml_ind, $xml_val, 
            $output, $tmpfile);

      /*
       * Service the get_features request
       * This requires a binary response.
       */
      } elseif(isset($xml_ind['GET_FEATURES'])) {
        processGetFeatures($map, $xml_ind, $xml_val, $output, $tmpfile);       

      /*
       * Service get_image request
       */
      } elseif(isset($xml_ind['GET_IMAGE'])) {
        processGetImage($map, $servicename, $xml_ind, $xml_val, 
            $output, $tmpfile);

      /*
       * No requests other that those checked above are handled.  Anything
       * else throws an error. ERR0702 indicates an invalid request.
       */
      } else {
        beginXMLFile($output);
        writeStartTag($output, "ERROR", array(
            "machine" => posix_uname(), 
            "processid" => posix_getpid(), "threadid" => ""));
        fwrite($output, "[ERR0702] Not a valid imsemu request.");
        writeEndTag($output, "ERROR");
        outputBufferFile($output, $tmpname);
      }
    }
  }

/*
 * This writes the initial common tags to the given output handle.
 */
function beginXMLFile($output) {
// Prepare to output result document
  fwrite($output, "<?xml version=\"1.0\"?>\n");
  fwrite($output, "<ARCXML version=\"1.0\">\n");
  global $needNewLine;
  writeStartTag($output, "RESPONSE");
}
/*
 * Since most, but not all, of the responses return ARCXML output
 * it made sense to pull this out and use many calls instead of 
 * leaving it in and having two or three cases that had to work around
 * it.  This method assumes that the output is being written to a 
 * temporary file, then written to standard output when complete.  
 * Some sort of buffering is required to deal with the custom stream
 * option, but this method won't support incremental output.
 */
function endXMLFileAndOutput($output, $tmpfile) {
// Finish document and write out.
  writeEndTag($output, "RESPONSE");
  writeEndTag($output, "ARCXML");
  outputBufferFile($output, $tmpfile);
}

/*
 * Outputs the buffer file to stdout, adding the customstream
 * details if required, and closes the file.
 */
function outputBufferFile($output, $tmpfile) {
  fflush($output);
  rewind($output);
  if(strtolower($_GET['customstream']) == 'true') {
    printf("%c%c%c%c", 0, 0, 0, 100); 
    $fsize = filesize($tmpfile);
    $byte1 = ($fsize / 0x1000000) % 0x100;
    $byte2 = ($fsize / 0x10000) % 0x100;
    $byte3 = ($fsize / 0x100) % 0x100;
    $byte4 = $fsize % 0x100;
    printf("%c%c%c%c", $byte1, $byte2, $byte3, $byte4);
  }
  while(!feof($output)) {
    print(fread($output, 1024));
  }
  if(strtolower($_GET['customstream']) == 'true') {
    printf("%c%c%c%c", 0, 0, 0, 102);
  }
  fclose($output);
  unlink($tmpfile);
}

/*
 * Since the catalog can conceivably be called two ways, it is done
 * in a single method.  It never will be, but lets be thorough.
 */  
function writeCatalog($output, $map_file, $map_type, $tmpfile) {
  global $needNewLine;
  $needNewLine = false;
  global $needUpper;
  $needUpper = true;
  beginXMLFile($output);
  writeStartTag($output, "SERVICES");
  foreach ($map_file as $a => $b) {
    /*
     * The attributes group, desc and version are not in the ARCXML
     * reference.  Group and desc were included by Paul, and so I've
     * included them (I'm such a sheep), and version was found in the
     * response from www.geographynetwork.ca
     */
    $param = array();
    $param['name'] = $a;
    $param['access'] = "PUBLIC";
    $param['group'] = "*";
    $param['desc'] = $a;
    $param['status'] = "ENABLED";
    $param['version'] = "";
    if($map_type[$a] == "feature") { 
      $param['type'] = "FeatureServer";
      $param['servicegroup'] = "FeatureServer1";
    } else {
      $param['type'] = "ImageServer";
      $param['servicegroup'] = "ImageServer1";
    }
    writeStartTag($output, "SERVICE", $param);
    writeEmptyTag($output, "IMAGE", array(
           "type" => "JPG"));
    writeStartTag($output, "ENVIRONMENT");
    writeEmptyTag($output, "LOCALE", array(
          "country" => "US", "language" => "en", "variant" => ""));
    writeEndTag($output, "ENVIRONMENT");
    writeEmptyTag($output, "CLEANUP", array("interval" => "0"));
    writeEndTag($output, "SERVICE");
  }
  writeEndTag($output, "SERVICES");
  endXMLFileAndOutput($output, $tmpfile);
}

/*
 * Creates an opening tag with the given name and parameters.
 * The parameters names are required by arcmap to be upper case.
 * eg. <EXACT value="1" label="National Capital">
 */
function writeStartTag($output, $name, $params = array()) {
  global $needUpper;
  fwrite($output, "<$name");
  foreach($params as $a => $b) {
    if($needUpper) {
      $a = strtoupper($a);
    }
    fwrite($output, " $a=\"$b\"");
  }
  fwrite($output, ">");
  global $needNewLine;
  if($needNewLine) {
    fwrite($output, "\r\n");
  }
}

/*
 * Creates a self closing tag with the given name and parameters.
 * eg. <FEATURECOORDSYS id="4267" />
 */
function writeEmptyTag($output, $name, $params = array()) {
  global $needUpper;
  fwrite($output, "<$name");
  foreach($params as $a => $b) {
    if($needUpper) {
      $a = strtoupper($a);
    }
    fwrite($output, " $a=\"$b\"");
  }
  fwrite($output, " />");
  global $needNewLine;
  if($needNewLine) {
    fwrite($output, "\r\n");
  }
}

/*
 * Closes the tag with the given name.  Parameters in a 
 * closing tag would be weird.
 * eg. </EXACT>
 */
function writeEndTag($output, $name) {
  fwrite($output, "</$name>");
  global $needNewLine;
  if($needNewLine) {
    fwrite($output, "\r\n");
  }
}

/*
 * This function take an int (signed sysdependent length),
 * and returns a single byte string with the ascii value
 * of the lowest byte of the integer.  The convertion is 
 * acheived by truncation.
 */
function createOneByteUnsignedString($int) {
  $byte1 = $int % 0x100;
  $result = sprintf("%c", $byte1);
  return $result;
}

/*
 * This function takes an int and returns a two byte string
 * with the ascii values of the lowers two bytes of the integer.
 */
function createTwoByteUnsignedString($int) {
  $result = "";
  $byte1 = ($int / 0x100) % 0x100;
  $byte2 = $int % 0x100;
  sprintf($result, "%c%c", $byte1, $byte2);
  return $result;
}

/*
 * This is in case the systems idea of an integer is not
 * four bytes.
 */
function createFourByteUnsignedString($int) {
  $result = "";
  $byte1 = ($int / 0x1000000) % 0x100;
  $byte2 = ($int / 0x10000) % 0x100;
  $byte3 = ($int / 0x100) % 0x100;
  $byte4 = $int % 0x100;
  sprintf($result, "%c%c%c%c", $byte1, $byte2, $byte3, $byte4);
  return $result;
}

/*
 * Sets the colour object in the given class to the colour identified
 * by the supplied string of the format /\d+,\d+,\d+/
 */
function setColour(&$clrObj, $rgbStr) {
  if(isColour($rgbStr)) {
    list($r, $g, $b) = split(",", $rgbStr);
    $clrObj->setRGB($r, $g, $b);
  }
}

/*
 * Determines if the given string represents a colour.
 */
function isColour($rgbStr) {
  list($r, $g, $b) = split(",", $rgbStr);
  if($r >= 0 && $r < 256 && $g >= 0 && $g < 256 && $b >= 0 && $b < 256) {
    return 1;
  } else {
    return 0;
  }
}

/*
 * Extracts the colour from the given class and returns it as a string
 * of the form /\d+,\d+,\d/
 */
function stringifyColour($clrObj) {
  $st = $clrObj->red . ", " . $clrObj->green . ", " . $clrObj->blue;
  return $st;
}

/*
 * This function assumes that beginXMLFile has been called,
 * and calls endXmlFileAnd Output to write out.  It is also
 * assumed that no tags have been written prior to calling this
 * function.  This is not a safe assumption in general, but the 
 * few special cases that use is aren't complaining.
 */
function writeErrorMessageAndDie($output, $tmpfile, $message) {
  global $needNewLine;
  $needNewLine = true;
  writeStartTag($output, "ERROR", array(
      "machine" => "IMSEmu " . PHP_OS . "; " . $_SERVER["SERVER_SOFTWARE"] . "; PHP " . phpversion() . " " . php_sapi_name(),
      "processid" => "0", "threadid" => ""));
  fwrite($output, $message);
  writeEndTag($output, "ERROR");
  endXMLFileAndOutput($output, $tmpfile);
  die(1);
}

/*
 * Like above, but adds the initial xml tags as well.
 */
function writeFullErrorMessageAndDie($output, $tmpfile, $message) {
  global $needNewLine;
  $needNewLine = true;
  beginXMLFile($output);
  writeErrorMessageAndDie($output, $tmpfile, $message);
}

/*
 * Determines the system time in number of micro seconds.  
 */
function getmicrotime() {
  list($usec, $sec) = explode(" ", microtime());
  return ((float)$usec + (float)$sec);
}

/*
 * This method loads the configuration file and generates the expected arrays.
 */
function getConfiguration(&$map_file, &$map_epsg, &$map_type, &$temp_dir) {
  $configFile = @fopen("Esrimap.cfg", 'r');
  if(!$configFile) {
    writeLog("Config file Esrimap.cfg not found.", 0);
    return -1;
  }
  writeLog("Parsing configuration file.", 0);
  $linenumber = 0;
  while(!feof($configFile)) {
    $line = trim(fgets($configFile));
    $linenumber++;
    if(substr($line, 0, 1) != '#') {
      list($element, $value) = @explode(' ', $line, 2);
      writeLog($element . ", " . $value, 5);
      if(!isset($element) || $element == '') {
        continue;
      }
      if(isset($config)) {
        if(!isset($service)) {
          if($element == "SERVICE") {
            $service = array();
          } else if($element == 'TEMPDIR') {
            $temp_dir = $value;
          } else if($element == 'END') {
            unset($config);
          } else {
            writeLog("Unrecognized tag found: '" . $element . "'", 5);
          }
        } else {
          // we are in a service block
          if($element == 'NAME') {
            if(!isset($value)) {
              writeLog("No NAME value found, line " . $linenumber, 0);
              return -1;
            } else {
              $service['NAME'] = $value;
            }
          } elseif($element == 'TYPE') {
            if(!isset($value)) {
              writeLog("No TYPE value found, line " . $linenumber, 0);
              return -1;
            } else {
              $value = strtolower($value);
              if($value != 'image' && $value != 'feature') {
                writeLog("Invalid TYPE value " . $value . " found, line " .
                    $linenumber, 0);
                return -1;
              } else {
                $service['TYPE'] = $value;
              }
            }
          } elseif($element == 'PROJECTION') {
            if(!isset($value)) {
              writeLog("No PROJECTION value found, line " . $linenumber, 0); 
              return -1;
            } else {
              $service['PROJECTION'] = $value;
            }
          } elseif($element == 'STATUS') {
            if(!isset($value)) {
              writeLog("No STATUS value found, line " . $linenumber, 0);
              return -1;
            } else {
              $value = strtolower($value);
              if($value != 'on' && $value != 'off') {
                writeLog("Invalid STATUS value " . $value . " found, line " . 
                    $linenumber, 0);
                return -1;
              } else {
                $service['STATUS'] = $value;
              }
            }
          } elseif($element == 'MAP') {
            if(!isset($value)) {
              writeLog("No MAP value found, line " . $linenumber, 0);
              return -1;
            } else {
              $service['MAP'] = $value;
            }
          } elseif($element == 'END') {
            if(!isset($service['STATUS'])) {
              writeLog("No STATUS value declared, defaulting to ON.", 5);
              $service['STATUS'] = 'on';
            } elseif(!isset($service['NAME'])) {
              writeLog("No NAME value declared in SERVICE ending line " .
                  $linenumber, 0);
              return -1;
            } elseif(!isset($service['TYPE'])) {
              writeLog("No TYPE value declared in SERVICE ending line " .
                  $linenumber, 0);
              return -1;
            } elseif(!isset($service['PROJECTION'])) {
              writeLog("No PROJECTION value declared in SERVICE ending line " .
                  $linenumber, 0);
              return -1;
            } elseif(!isset($service['MAP'])) {
              writeLog("No MAP value declared in SERVICE ending line " .
                  $linenumber, 0);
              return -1;
            }
            if($service['STATUS'] == 'on') {
              writeLog("Enabling " . $service['NAME'] . ": " . 
                  $service['MAP'] . ", " . $service['PROJECTION'] . 
                  ", " . $service['TYPE'], 5);
              $map_file[$service['NAME']] = $service['MAP'];
              $map_epsg[$service['NAME']] = $service['PROJECTION'];
              $map_type[$service['NAME']] = $service['TYPE'];
            } 
            unset($service);
          }
        }
      } else {
        if($element == 'CONFIG') {
          $config = 1;
        }
      }
    }
  }
  fclose($configFile);
  return 0;
}

/*
 * These are the basic symbol types supported by ArcIMS.  They must
 * be defined in Mapserver to be used.  Currently, not all are
 * defined in Esrimap.sym.
 * The 'solid' polygon and line symbol types are defaults, so they are
 * not included in the symbol file or lookup.
 */
/*
 * The next three functions make arrays of symbol type available.
 * Each type contains a listing of the standard symbols supported by 
 * ARCXML, and must be defined in the symbols file.  A symbols file,
 * Esrimap.sym, is provided with imsemu.  
 * The polygon symbol type, 'solid', is not provided, nor should it be.
 * This name conflicts with the solid line type, and is the default type
 * in both ARCXML and mapserver, so emu functions correctly without it defined.
 */
function getMarkerSymbolTypeArray() {
  $markersymboltype = array('circle' => 1, 'triangle' => 1, 'square' => 1,
      'cross' => 1, 'star' => 1);
  return $markersymboltype;
}

function getLineSymbolTypeArray() {
  $linesymboltype = array('solid' => 1, 'dash' => 1, 'dot' => 1, 
        'dash_dot' => 1, 'dash_dot_dot' => 1);
  return $linesymboltype;
}

function getPolygonSymbolTypeArray() {
  $polygonsymboltype = array('bdiagonal' => 1, 'fdiagonal' => 1,
      'cross' => 1, 'diagcross' => 1, 'horizontal' => 1, 'vertical' => 1, 
      'gray' => 1, 'lightgray' => 1, 'darkgray' => 1);
  return $polygonsymboltype;
}

/*
 * This method allows a single point for handling log message redirection.
 */
function writeLog($string, $type) {
  if($type == 8) {
    /*
     * This is a debugging level that ensures the file is flushed and 
     * closed after every call.  It is slow, but ensures that all output
     * is retrievable.
    */
    /*
    $debugfile = fopen("./Esrimap.log", "a");
    fwrite($debugfile, $string . "\n");
    fclose($debugfile);
    */
  } elseif($type == 7) {
    /*
     * This level is for dumping large things that don't need to be
     * in the server log, such as map/layer/class/style class 
     * structures.
     */
    /*
    $debugfile = fopen("./Objects.log", "a");
    fwrite($debugfile, $string . "\n");
    fclose($debugfile);
    */
  } elseif($type == 5) {
    /*
     * Detaileder logging from Esrimap.
     */
    //error_log($string, 0);
  } elseif($type == 4) {
    /*
     * Excessive logging in GetServiceInfo.
     */
    error_log($string, 0);
  } elseif($type == 3) {
    /*
     * More logging in GetImage.
     */
    //error_log($string, 0);
  } elseif($type == 2) {
    /*
     * This is used for more detailed logging in GetFeatures.
     */
    //error_log($string, 0);
  } elseif($type == 1) {
    /*
     * This is used for timing output.
     */
    //error_log($string, 0);
  } elseif($type == 0) {
    /*
     * General logging.  Output to the webserver error stream.
     */
    error_log($string, 0);
  }
}
?>
